Attribute VB_Name = "mCommonControls"
Option Explicit

Public Enum SortOrders
   Unsorted
   Acsending
   Descending
End Enum

Public Enum SortTypes
   ByText = &H0
   ByDate = &H1000
   ByValue = &H2000
End Enum
Public Const SORT_DESCENDING = &H80000000

'ListView messages
Private Const LVM_FIRST = &H1000
Private Const LVM_SETCOLUMNWIDTH = (LVM_FIRST + 30)
Private Const LVM_SORTITEMS = LVM_FIRST + 48
Private Const LVM_GETHEADER = (LVM_FIRST + 31)
Private Const LVM_GETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 55)
Private Const LVM_SETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 54) '// optional wParam == mask

'ListView styles
Public Enum LV_EX_STYLES
    LVS_EX_GRIDLINES = &H1
    LVS_EX_FULLROWSELECT = &H20
    LVS_EX_INFOTIP = &H400
    LVS_EX_BORDERSELECT = &H8000
    LVS_EX_DOUBLEBUFFER = &H10000
    LVS_EX_COMMON = &H421
    LVS_EX_ALL = &H18421
End Enum

'ToolBar messages
Private Const WM_USER As Long = &H400
Private Const TB_GETBUTTON As Long = WM_USER + 23
Private Const TB_GETBUTTONINFOW As Long = WM_USER + 63
Private Const TB_SETBUTTONINFOW As Long = WM_USER + 64
Private Const TB_GETBUTTONINFOA As Long = WM_USER + 65
Private Const TB_SETBUTTONINFOA As Long = WM_USER + 66
Private Const TB_SETEXTENDEDSTYLE As Long = WM_USER + 84
Private Const TB_SETSTYLE As Long = WM_USER + 56
Private Const TB_GETSTYLE As Long = WM_USER + 57

'ToolBar styles
Private Const TBSTYLE_EX_DRAWDDARROWS As Long = &H1 'Show dropdown arrow
Private Const TBSTYLE_WRAPABLE As Long = &H200      'buttons to wrap when form resized
Private Const TBSTYLE_FLAT As Long = &H800          'flat IE3+ style toolbar
Private Const TBSTYLE_LIST As Long = &H1000         'places captions beside buttons
'Button styles
Private Const TBSTYLE_DROPDOWN As Long = &H8    'Dropdown button
Private Const TBSTYLE_AUTOSIZE As Long = &H10   'Autosize button
Private Const TBIF_STYLE As Long = &H8
Private Const TBIF_LPARAM As Long = &H10

Private Type TVSORTCB
  hParent As Long
  lpfnCompare As Long
  lParam As Long
End Type

Private Const TVM_FIRST = &H1100
Private Const TVM_SORTCHILDREN = (TVM_FIRST + 19)
Private Const TVM_SORTCHILDRENCB = (TVM_FIRST + 21)
Private Const TVM_GETNEXTITEM As Long = (TVM_FIRST + 10)
Private Const TVM_DELETEITEM As Long = (TVM_FIRST + 1)
Private Const TVGN_ROOT As Long = &H0
Private Const WM_SETREDRAW As Long = &HB

Private Type tagInitCommonControlsEx
   lngSize As Long
   lngICC As Long
End Type
Public Declare Function InitCommonControls Lib "comctl32.dll" () As Boolean
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (iccex As tagInitCommonControlsEx) As Boolean

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" (Destination As Any, ByVal numBytes As Long)
Private Declare Sub FillMemory Lib "kernel32.dll" Alias "RtlFillMemory" (Destination As Any, ByVal Length As Long, ByVal Fill As Byte)

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long

Private Const ICC_USEREX_CLASSES = &H200
Private Const WS_CLIPCHILDREN As Long = &H2000000
Private Const GWL_STYLE = (-16)
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Private Const SM_CXBORDER = 5
Private Const SM_CYBORDER = 6

Public Function InitCommonControlsVB() As Boolean
   On Error Resume Next
   Dim iccex As tagInitCommonControlsEx
   With iccex
       .lngSize = LenB(iccex)
       .lngICC = ICC_USEREX_CLASSES
   End With
   InitCommonControlsEx iccex
   If Err Then
      InitCommonControlsVB = InitCommonControls
   Else
      InitCommonControlsVB = True
   End If
   On Error GoTo 0
End Function

Public Sub ProgressToStatus(ByVal pb As Object, ByVal sb As Object, ByVal nPanel As Long)
    Dim X As Long, Y As Long
    X = GetSystemMetrics(SM_CXBORDER) * Screen.TwipsPerPixelX
    Y = GetSystemMetrics(SM_CYBORDER) * Screen.TwipsPerPixelY
    'SetParent pb.hwnd, sb.hwnd
    With sb
        pb.Move .Panels(nPanel).Left + X, 4 * Y + sb.Top, .Panels(nPanel).Width - (2 * X), .Height - (8 * Y)
        pb.ZOrder 0
    End With
End Sub

Public Sub SetLVStyles(ByVal hwndLV As Long, Optional ByVal lvExStyles As LV_EX_STYLES = LVS_EX_COMMON)
   Dim lStyles As Long
   lStyles = SendMessage(hwndLV, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, ByVal 0&)
   lStyles = lStyles Or lvExStyles
   SendMessage hwndLV, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, ByVal lStyles
   SetWindowLong hwndLV, GWL_STYLE, GetWindowLong(hwndLV, GWL_STYLE) Or WS_CLIPCHILDREN
End Sub

Public Sub SetFlatToolbar(TBar As Object, Optional fHorizontalText As Boolean = False, Optional fWrapable As Boolean = False)
   Dim hTBar As Long
   Dim style As Long
   TBar.Refresh
   hTBar = FindWindowEx(TBar.hWnd, 0&, "ToolbarWindow32", vbNullString)
   style = SendMessage(hTBar, TB_GETSTYLE, 0&, ByVal 0&)
   style = style Or TBSTYLE_FLAT Or TBSTYLE_WRAPABLE
   If fHorizontalText Then style = style Or TBSTYLE_LIST
   Call SendMessage(hTBar, TB_SETSTYLE, 0&, ByVal style)
   TBar.Refresh
   If fWrapable = False Then
      style = style Xor TBSTYLE_WRAPABLE
      Call SendMessage(hTBar, TB_SETSTYLE, 0&, ByVal style)
   End If
   Call SendMessage(hTBar, TB_SETEXTENDEDSTYLE, 0&, ByVal TBSTYLE_EX_DRAWDDARROWS)
End Sub

Public Function ListView_SortItems(lv As Object, _
                              Optional ByVal columnIndex As Long = 0, _
                              Optional ByVal SortBy As SortTypes = ByText, _
                              Optional ByVal bDescending As Boolean = False)
    Dim lParam As Long
    lParam = columnIndex Or SortBy
    If bDescending Then lParam = lParam Or SORT_DESCENDING
    ListView_SortItems = ListView_Sort(lv.hWnd, AddressOf CompareLVProc, lParam)
End Function

Private Function ListView_Sort(hwndLV As Long, pfnCompare As Long, lParamSort As Long) As Boolean
   ListView_Sort = SendMessage(hwndLV, LVM_SORTITEMS, ByVal lParamSort, ByVal pfnCompare)
End Function

Public Sub ListView_AutosizeColumn(lv As Object, Optional ByVal column As Object = Nothing, Optional ByVal newSize As Long = -1)
   Dim c As Object 'ColumnHeader
   If column Is Nothing Then
      For Each c In lv.ColumnHeaders
         SendMessage lv.hWnd, LVM_SETCOLUMNWIDTH, c.Index - 1, ByVal newSize
      Next
   Else
      SendMessage lv.hWnd, LVM_SETCOLUMNWIDTH, column.Index - 1, ByVal newSize
   End If
End Sub

Public Sub ListView_AutosizeLastColumn(lv As Object)
   ListView_AutosizeColumn lv, lv.ColumnHeaders(lv.ColumnHeaders.Count), -2
End Sub

Public Sub TreeView_Clear(tv As Object)
   Dim tvHwnd As Long, hItem As Long
   tvHwnd = tv.hWnd
   SendMessage tvHwnd, WM_SETREDRAW, False, ByVal 0&
   Do
      hItem = SendMessage(tvHwnd, TVM_GETNEXTITEM, TVGN_ROOT, ByVal 0&)
      If hItem <= 0 Then Exit Do
      SendMessage tvHwnd, TVM_DELETEITEM, 0, ByVal hItem
   Loop
   SendMessage tvHwnd, WM_SETREDRAW, True, ByVal 0&
End Sub

Public Sub ListView_Clear(lv As Object)
   Dim lCount As Long, i As Long
   lCount = lv.ListItems.Count
   SendMessage lv.hWnd, WM_SETREDRAW, False, ByVal 0&
   For i = lCount To 1 Step -1
      lv.ListItems.Remove i
   Next
   SendMessage lv.hWnd, WM_SETREDRAW, True, ByVal 0&
End Sub

Public Sub Treeview_SortChildren(tv As TreeView, Optional parentNode As Node = Nothing)
   Dim scCB As TVSORTCB
   Dim hParent As Long
   If Not parentNode Is Nothing Then
      hParent = hItemFromNode(parentNode)
   End If
   With scCB
      .hParent = hParent
      .lParam = 0
      .lpfnCompare = FARPROC(AddressOf CompareTVProc)
   End With
   Call SendMessage(tv.hWnd, TVM_SORTCHILDRENCB, 0, scCB)
End Sub
'VB TreeView and ListView can sort items only by strings
'Here is process to compare items by date and size
Public Function CompareLVProc(ByVal lParam1 As Long, ByVal lParam2 As Long, ByVal lParamSort As Long) As Long
   Dim nColumn As Long
   Dim hr As Long
   Dim sortType As SortTypes
   Dim sCompare1 As String
   Dim sCompare2 As String
   Dim s1() As String, s2() As String
   
   Dim sFormatString As String
   Dim Item1 As Object, Item2 As Object
   On Error GoTo EndCompare
   Set Item1 = GetItemFromlParam(lParam1)
   Set Item2 = GetItemFromlParam(lParam2)
   hr = Item1.SmallIcon - Item2.SmallIcon
   If hr <> 0 Then GoTo EndCompare
   nColumn = lParamSort And Not (SORT_DESCENDING Or &H3000)
   sortType = lParamSort And Not SORT_DESCENDING And &H3000
   If nColumn = 0 Then
      sCompare1 = Item1.Text
      sCompare2 = Item2.Text
   Else
      sCompare1 = Item1.SubItems(nColumn)
      sCompare2 = Item2.SubItems(nColumn)
   End If
   If sortType = ByDate Then
      If IsDate(sCompare1) And IsDate(sCompare2) Then
         hr = Sgn(CDate(sCompare1) - CDate(sCompare2))
      Else
         hr = StrComp(sCompare1, sCompare2)
      End If
   ElseIf sortType = ByValue Then
      s1 = Split(sCompare1, "(")
      s2 = Split(sCompare2, "(")
      s1(0) = Replace(s1(0), "0x", "&H")
      s2(0) = Replace(s2(0), "0x", "&H")
      If IsNumeric(s1(0)) And IsNumeric(s2(0)) Then
         hr = Sgn(CDec(s1(0)) - CDec(s2(0)))
      Else
         hr = StrComp(sCompare1, sCompare2)
      End If
   Else
      hr = StrComp(sCompare1, sCompare2, vbTextCompare)
   End If
EndCompare:
   On Error GoTo 0
   Err.Clear
   If (lParamSort And SORT_DESCENDING) Then hr = hr * (-1)
    Set Item1 = Nothing
    Set Item2 = Nothing
    CompareLVProc = hr
End Function

Private Function CompareTVProc(ByVal lParam1 As Long, ByVal lParam2 As Long, ByVal lParamSort As Long) As Long
   Dim hr As Long
   Dim Item1 As Object, Item2 As Object
   On Error GoTo ErrCompare
   Set Item1 = GetItemFromlParam(lParam1)
   Set Item2 = GetItemFromlParam(lParam2)
   hr = Item1.Image - Item2.Image
   If hr = 0 Then hr = StrComp(Item1.Text, Item2.Text)
   If (lParamSort And SORT_DESCENDING) Then hr = hr * (-1)
ErrCompare:
    On Error GoTo 0
    Err.Clear
    Set Item1 = Nothing
    Set Item2 = Nothing
    CompareTVProc = hr
End Function

Private Function GetItemFromlParam(lParam As Long) As Object
  Dim pItem As Long
  Dim oItem As Object
  If lParam Then
    CopyMemory pItem, ByVal lParam + 8, 4
    If pItem Then
      CopyMemory oItem, pItem, 4&
      Set GetItemFromlParam = oItem
      FillMemory oItem, 4, 0
    End If
  End If
End Function

Private Function hItemFromNode(nd As Object) As Long
   Dim hItem As Long
  ' Node's hItem is in adw0(17) (@ byte offset 68)
   CopyMemory hItem, ByVal (ObjPtr(nd) + 68), 4&
   hItemFromNode = hItem
End Function

Private Function FARPROC(pfn As Long) As Long
  FARPROC = pfn
End Function


