Attribute VB_Name = "mMisc"
Option Explicit

Public Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Public Type FILETIME
     dwLow As Long
     dwHigh As Long
End Type

Public Type TIME_ZONE_INFORMATION
    Bias As Long
    StandardName(0 To 31) As Integer
    StandardDate As SYSTEMTIME
    StandardBias As Long
    DaylightName(0 To 31) As Integer
    DaylightDate As SYSTEMTIME
    DaylightBias As Long
End Type

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, _
                                                              lpSystemTime As SYSTEMTIME) As Long
Private Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpFileTime As FILETIME, _
                                                                lpLocalFileTime As FILETIME) As Long

Private Declare Function SystemTimeToTzSpecificLocalTime Lib "kernel32" (lpTimeZoneInformation As TIME_ZONE_INFORMATION, lpUniversalTime As SYSTEMTIME, lpLocalTime As SYSTEMTIME) As Long
Private Declare Function SystemTimeToLocalTime Lib "kernel32" Alias "SystemTimeToTzSpecificLocalTime" _
                (ByVal lpTZ As Long, lpUniversalTime As SYSTEMTIME, lpLocalTime As SYSTEMTIME) As Long
Private Declare Function GetTimeZoneInformation Lib "kernel32" (lpTimeZoneInformation As TIME_ZONE_INFORMATION) As Long

Private Declare Function ExpandEnvironmentStrings Lib "kernel32.dll" _
                Alias "ExpandEnvironmentStringsA" ( _
                ByVal lpSrc As String, _
                ByVal lpDst As String, _
                ByVal nSize As Long) As Long

Public Declare Function GetLastError Lib "kernel32" () As Long
Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Long, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Args As Any) As Long
Private Const FORMAT_MESSAGE_FROM_SYSTEM As Long = &H1000

Private Declare Function QueryDosDeviceW Lib "kernel32.dll" (ByVal lpDeviceName As Long, _
                ByVal lpTargetPath As Long, ByVal ucchMax As Long) As Long
                
Private Declare Function GetLogicalDriveStringsA Lib "kernel32" (ByVal nBufferLength As Long, lpBuffer As Any) As Long
Public Const MAX_PATH = 260
Public Const OFFSET_2 = 65536

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Const GWL_STYLE = (-16)
Const ES_NUMBER = &H2000&

Public Sub SetNumeric(tx As TextBox)
    SetWindowLong tx.hWnd, GWL_STYLE, GetWindowLong(tx.hWnd, GWL_STYLE) Or ES_NUMBER
End Sub

Public Sub RemoveNumeric(tx As TextBox)
    If (GetWindowLong(tx.hWnd, GWL_STYLE) And ES_NUMBER) = ES_NUMBER Then
       SetWindowLong tx.hWnd, GWL_STYLE, GetWindowLong(tx.hWnd, GWL_STYLE) And Not ES_NUMBER
    End If
End Sub

Public Function ExpandEnvironmentString(ByVal strExpand As String) As String
   Dim strBuffer As String
   strBuffer = String(MAX_VALUE_SIZE, 0)
   Dim lSize As Long
   lSize = MAX_VALUE_SIZE
   lSize = ExpandEnvironmentStrings(strExpand, strBuffer, lSize)
   If lSize > 1 Then
      ExpandEnvironmentString = Left(strBuffer, lSize - 1)
   End If
End Function

Public Function MultiDataToText(abData() As Byte) As String
   MultiDataToText = MultiStringToText(StrConv(abData, vbUnicode))
End Function
Public Function MultiStringToText(ByVal sMulti As String) As String
   Dim sTemp As String
   sTemp = TrimDblNull(sMulti)
   If sTemp = Chr(0) Then Exit Function
   MultiStringToText = Replace(sTemp, Chr(0), vbCrLf)
End Function

Public Function FileTimeToVBDate(ft As FILETIME, Optional bUTC As Boolean = True) As Date
  Dim st As SYSTEMTIME
  FileTimeToSystemTime ft, st
  If Not bUTC Then
     SystemTimeToLocalTime 0, st, st
  End If
  On Error Resume Next
  FileTimeToVBDate = DateSerial(st.wYear, st.wMonth, st.wDay) + _
                     TimeSerial(st.wHour, st.wMinute, st.wSecond) ' + st.wMilliseconds / 86400 / 1000
  If Err Then
     Err.Clear
     FileTimeToVBDate = DateSerial(1600, 1, 1)
  End If
End Function

Public Function TrimNull(startstr As String) As String
   Dim pos As Long
   pos = InStr(startstr, Chr$(0))
   If pos Then
      TrimNull = Left$(startstr, pos - 1)
      Exit Function
   End If
   TrimNull = startstr
End Function

Public Function TrimDblNull(startstr As String) As String
   Dim pos As Long
   pos = InStr(startstr, Chr$(0) & Chr$(0))
   If pos Then
      TrimDblNull = Left$(startstr, pos - 1)
      Exit Function
   End If
   TrimDblNull = startstr
End Function

Public Function HexPad(ByVal x As Long, ByVal n As Long) As String
   HexPad = Right(String(n, "0") & Hex(x), n)
End Function

Public Function ApiError(ByVal ErrNum As Long) As String
   Dim msg As String, s As String
   Dim nRet As Long
   msg = Space$(1024)
   nRet = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, ErrNum, 0&, msg, Len(msg), ByVal 0&)
   s = "Error #" & ErrNum
   If nRet Then
      s = s & vbCrLf & Left(msg, nRet)
   End If
   ApiError = s
End Function

Public Function GetNtDeviceNameForDrive(ByVal sDrive As String) As String
   Dim bDrive() As Byte
   Dim bResult() As Byte
   Dim lR As Long
   Dim sDeviceName As String

   If Right(sDrive, 1) = "\" Then
      If Len(sDrive) > 1 Then
         sDrive = Left(sDrive, Len(sDrive) - 1)
      End If
   End If
   bDrive = sDrive
   ReDim Preserve bDrive(0 To UBound(bDrive) + 2) As Byte
   ReDim bResult(0 To MAX_PATH * 2 + 1) As Byte
   lR = QueryDosDeviceW(VarPtr(bDrive(0)), VarPtr(bResult(0)), MAX_PATH)
   If (lR > 2) Then
      sDeviceName = bResult
      sDeviceName = Left(sDeviceName, lR - 2)
      GetNtDeviceNameForDrive = sDeviceName
   End If
End Function

Public Function GetDrives() As Collection
   Dim colDrives As New Collection
   Dim lSize As Long
   Dim lR As Long
   Dim iLastPos As Long
   Dim iPos As Long
   Dim sDrive As String
   Dim sDriveStrings As String

   lSize = GetLogicalDriveStringsA(0, ByVal 0&)
   sDriveStrings = String(lSize + 1, 0)
   lR = GetLogicalDriveStringsA(lSize, ByVal sDriveStrings)
   iLastPos = 1
   Do
      iPos = InStr(iLastPos, sDriveStrings, vbNullChar)
      If Not (iPos = 0) Then
         sDrive = Mid$(sDriveStrings, iLastPos, iPos - iLastPos)
         iLastPos = iPos + 1
      Else
         sDrive = Mid$(sDriveStrings, iLastPos)
      End If
      If Len(sDrive) > 0 Then
         colDrives.Add sDrive
      End If
   Loop While Not (iPos = 0)
   Set GetDrives = colDrives
End Function

Public Function GetDriveForNtDeviceName(ByVal sDeviceName As String) As String
   Dim sFoundDrive As String
   Dim colDrives As Collection
   Dim vDrive As Variant
   For Each vDrive In GetDrives()
      If (GetNtDeviceNameForDrive(vDrive) = sDeviceName) Then
         sFoundDrive = vDrive
         Exit For
      End If
   Next
   GetDriveForNtDeviceName = sFoundDrive
End Function

Public Function KeyExists(ByRef col As Collection, ByVal Key As String) As Boolean
    On Error Resume Next
    KeyExists = (VarType(col.Item(Key)) <> VbVarType.vbEmpty)
    On Error GoTo 0
End Function

Public Function IntToUINT(ByVal i As Integer) As Long
   If i < 0 Then
       IntToUINT = i + OFFSET_2
   Else
      IntToUINT = i
   End If
End Function

Public Sub ParseBinaryData(ByRef binData() As Byte, ByRef sText As String, ByRef sAscii As String)
   Dim arrLine() As String
   Dim asc As String, sLine As String
   Dim i As Long, j As Long, n As Long, bytVal As Byte
   For i = 0 To UBound(binData) Step 8
       asc = ""
       ReDim arrLine(8)
       For j = 0 To 7
           n = i + j
           If n <= UBound(binData) Then
              bytVal = binData(n)
              If bytVal > 31 Then
                 asc = asc & Chr(bytVal)
              Else
                 asc = asc & "."
              End If
              arrLine(j) = HexPad(binData(n), 2)
           Else
              arrLine(j) = "  "
           End If
       Next j
       arrLine(8) = "| " & asc
       sLine = HexPad(i, 4) & " | " & Join(arrLine, " ")
       If sText <> "" Then sText = sText & vbCrLf
       sText = sText & sLine
       sAscii = sAscii & asc
   Next i
End Sub

Public Function BinToAsc(ByRef binData() As Byte) As String
   Dim nBound As Long
   nBound = SafeUBound(binData)
   If nBound = -1 Then Exit Function
   Dim asc() As String
   Dim i As Long, bytVal As Byte
   ReDim asc(nBound)
   For i = 0 To nBound
      bytVal = binData(i)
      If bytVal < 32 Then asc(i) = "." Else asc(i) = Chr(bytVal)
   Next i
   BinToAsc = Join(asc, "")
End Function

Public Function SafeUBound(abData As Variant) As Long
   On Error Resume Next
   SafeUBound = UBound(abData)
   If Err Then SafeUBound = -1
   On Error GoTo 0
End Function

Public Function StartWith(ByVal strCheck As String, ByVal strStart As String, Optional bIgnoreCase As Boolean) As Boolean
   If Len(strCheck) < Len(strStart) Then Exit Function
   Dim comp As VbCompareMethod
   If bIgnoreCase Then comp = vbTextCompare Else comp = vbBinaryCompare
   If StrComp(Left(strCheck, Len(strStart)), strStart, comp) = 0 Then
      StartWith = True
   End If
End Function
