Attribute VB_Name = "mUSBInfo"
Option Explicit

Private Const USBKEY = "SYSTEM\CurrentControlSet\Enum\USB"
Private Const USBSTORKEY = "SYSTEM\CurrentControlSet\Enum\USBSTOR"
Private Const DEVINTERFACE_DISK = "SYSTEM\CurrentControlSet\Control\DeviceClasses\{53f56307-b6bf-11d0-94f2-00a0c91efb8b}"
Private Const DEVINTERFACE_VOLUME = "SYSTEM\CurrentControlSet\Control\DeviceClasses\{53F5630D-B6BF-11D0-94F2-00A0C91EFB8B}"
Private Const DRIVERS = "SYSTEM\CurrentControlSet\Control\Class\"
Private Const MOUNTEDDEVICES = "SYSTEM\MountedDevices"
Private m_ColDosDevices As Collection

Public Sub EnumUsbDevices(colUSB As Collection)
   Set colUSB = New Collection
   EnumDosDevices
   EnumUsbKey colUSB
   EnumUsbStorageKey colUSB
End Sub

Private Sub EnumUsbKey(ByRef colUSB As Collection)
   Dim i As Long, j As Long, nKeys As Long, nSubkeys As Long
   Dim hKey As Long, hSubKey As Long, hInstKey As Long, hControlKey As Long
   Dim sName As String, sInstName As String
   Dim parts() As String
   Dim ft As FILETIME
   Dim device As cUSBDevice
   Dim instance As cUSBInctance
   If RegOpenKeyEx(HKEY_LOCAL_MACHINE, USBKEY, 0, KEY_READ, hKey) = 0 Then
      Call RegQueryInfoKey(hKey, vbNullString, ByVal 0&, 0, nKeys, 0, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&)
      For i = 0 To nKeys - 1
          sName = String(255, 0)
          If RegEnumKeyEx(hKey, i, sName, 255, 0, ByVal 0&, 0, ft) = 0 Then
             sName = TrimNull(sName)
             If Left(sName, 3) = "Vid" Then
                Set device = New cUSBDevice
                device.DeviceKeyChanged = FileTimeToVBDate(ft)
                ParseDevKey sName, device
                Set device.Instancies = New Collection
                If RegOpenKeyEx(hKey, sName, 0, KEY_READ, hSubKey) = 0 Then
                   Call RegQueryInfoKey(hSubKey, vbNullString, ByVal 0&, 0, nSubkeys, 0, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&)
                   For j = 0 To nSubkeys - 1
                       sName = String(255, 0)
                       If RegEnumKeyEx(hSubKey, j, sName, 255, 0, ByVal 0&, 0, ft) = 0 Then
                          sName = TrimNull(sName)
                          If RegOpenKeyEx(hSubKey, sName, 0, KEY_READ, hInstKey) = 0 Then
                             Set instance = New cUSBInctance
                             With instance
                                 .DeviceName = GetValueAsString(hInstKey, "LocationInformation")
                                 .Description = GetValueAsString(hInstKey, "DeviceDesc")
                                 .DeviceMfg = GetValueAsString(hInstKey, "Mfg")
                                 .DeviceClass = GetValueAsString(hInstKey, "Class")
                                 .ServiceName = GetValueAsString(hInstKey, "Service")
                                 .FriendlyName = GetValueAsString(hInstKey, "FriendlyName")
                                 .parentID = GetValueAsString(hInstKey, "ParentIdPrefix")
                                 parts = Split(GetValueAsString(hInstKey, "HardwareID"), vbCrLf)
                                 .InstanceID = parts(0)
                                 parts = Split(parts(0), "\")
                                 If UBound(parts) > 0 Then
                                    parts = Split(parts(1), "&")
                                    .VendorID = Replace(parts(0), "Vid_", "")
                                    .ProductID = Replace(parts(1), "Pid_", "")
                                    If UBound(parts) > 1 Then .Revision = Replace(parts(2), "Rev_", "")
                                 End If
                                 parts = Split(GetValueAsString(hInstKey, "CompatibleIDs"), vbCrLf)
                                 parts = Split(parts(0), "\")
                                 If UBound(parts) > 0 Then
                                    parts = Split(parts(1), "&")
                                    .USBClass = Replace(parts(0), "Class_", "")
                                    If UBound(parts) > 0 Then .USBSubClass = Replace(parts(1), "SubClass_", "")
                                    If UBound(parts) > 1 Then .USBProto = Replace(parts(2), "Prot_", "")
                                 End If
                                 If RegOpenKeyEx(hInstKey, "Control", ByVal 0, KEY_READ, hControlKey) = 0 Then
                                    Call RegQueryInfoKey(hSubKey, vbNullString, ByVal 0&, 0, ByVal 0&, 0, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ft)
                                    .Connected = True
                                    RegCloseKey hControlKey
                                 End If
                                 .InstanceKeyChanged = FileTimeToVBDate(ft)
                             End With
                             GetDriverInfo GetValueAsString(hInstKey, "Driver"), instance
                             If InStr(1, sName, "&") = 0 Then
                                 instance.SerialNumber = sName
                                 device.Instancies.Add instance, "key_" & sName
                             Else
                                 device.Instancies.Add instance
                             End If
                             RegCloseKey hInstKey
                          End If
                       End If
                   Next j
                   RegCloseKey hSubKey
                   colUSB.Add device
                End If
             End If
          End If
      Next i
      RegCloseKey hKey
   End If
End Sub

Private Sub EnumUsbStorageKey(ByRef colUSB As Collection)
   Dim i As Long, j As Long, nKeys As Long, nSubkeys As Long
   Dim hKey As Long, hSubKey As Long, hInstKey As Long, hControlKey As Long
   Dim sName As String, sInstName As String
   Dim parts() As String
   Dim ft As FILETIME
   If RegOpenKeyEx(HKEY_LOCAL_MACHINE, USBSTORKEY, 0, KEY_READ, hKey) = 0 Then
      Call RegQueryInfoKey(hKey, vbNullString, ByVal 0&, 0, nKeys, 0, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&)
      For i = 0 To nKeys - 1
          sName = String(255, 0)
          If RegEnumKeyEx(hKey, i, sName, 255, 0, ByVal 0&, ByVal 0&, ByVal 0&) = 0 Then
             sName = TrimNull(sName)
                If RegOpenKeyEx(hKey, sName, 0, KEY_READ, hSubKey) = 0 Then
                   Call RegQueryInfoKey(hSubKey, vbNullString, ByVal 0&, 0, nSubkeys, 0, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&)
                   For j = 0 To nSubkeys - 1
                       sName = String(255, 0)
                       If RegEnumKeyEx(hSubKey, j, sName, 255, 0, ByVal 0&, 0, ft) = 0 Then
                          sName = TrimNull(sName)
                          Dim instance As cUSBInctance
                          Set instance = GetInstance(Split(sName, "&")(0), colUSB)
                          If Not instance Is Nothing Then
                             If RegOpenKeyEx(hSubKey, sName, 0, KEY_READ, hInstKey) = 0 Then
                                With instance
                                    If .FriendlyName = "" Then
                                       .FriendlyName = GetValueAsString(hInstKey, "FriendlyName")
                                    End If
                                    If .parentID = "" Then
                                       .parentID = GetValueAsString(hInstKey, "ParentIdPrefix")
                                    End If
                                    If .parentID <> "" Then
                                       On Error Resume Next
                                       .driveLetter = m_ColDosDevices(.parentID)
                                       On Error GoTo 0
                                    End If
                                End With
                                RegCloseKey hInstKey
                             End If
                          End If
                       End If
                   Next j
                   RegCloseKey hSubKey
                End If
          End If
      Next i
      RegCloseKey hKey
   End If
End Sub

Private Sub EnumDosDevices()
   Dim hKey As Long, nValues As Long, i As Long
   Dim sName As String, sValue As String, driveLetter As String, parentID As String
   Dim parts() As String
   Set m_ColDosDevices = New Collection
   If RegOpenKeyEx(HKEY_LOCAL_MACHINE, MOUNTEDDEVICES, 0, KEY_READ, hKey) = 0 Then
      Call RegQueryInfoKey(hKey, vbNullString, ByVal 0&, 0, ByVal 0&, 0, ByVal 0&, nValues, ByVal 0&, ByVal 0&, ByVal 0&, ByVal 0&)
      For i = 0 To nValues - 1
          sName = String(255, 0)
          If RegEnumValue(hKey, i, sName, 255, 0, ByVal 0&, ByVal 0&, ByVal 0&) = 0 Then
             sName = TrimNull(sName)
             If Len(sName) > 10 Then
                If Left(sName, 11) = "\DosDevices" Then
                   sValue = GetValueAsUnicodeString(hKey, sName)
                   If Len(sValue) > 0 Then
                      If Left(sValue, 1) = "\" Then
                         parts = Split(sName, "\")
                         driveLetter = parts(UBound(parts))
                         parts = Split(sValue, "#")
                         If UBound(parts) > 1 Then
                            parentID = Replace(parts(2), "&RM", "")
                            m_ColDosDevices.Add driveLetter, parentID
                         End If
                      End If
                   End If
                End If
             End If
          End If
      Next i
   End If
End Sub

Private Function GetInstance(ByVal serial As String, ByRef colUSB As Collection) As cUSBInctance
   Dim dev As cUSBDevice
   Dim inst As cUSBInctance
   Dim bFound As Boolean
   For Each dev In colUSB
       For Each inst In dev.Instancies
          If inst.SerialNumber = serial Then
             Set GetInstance = inst
             bFound = True
             Exit For
          End If
       Next
       If bFound Then Exit For
   Next
End Function

Private Sub ParseDevKey(ByVal keyName As String, ByRef dev As cUSBDevice)
   Dim parts() As String
   parts = Split(keyName, "&")
   dev.VendorID = Replace(parts(0), "Vid_", "")
   If UBound(parts) > 0 Then dev.ProductID = Replace(parts(1), "Pid_", "")
End Sub

Private Sub GetDriverInfo(ByVal drvKey As String, ByRef instance As cUSBInctance)
    Dim hKey As Long, ft As FILETIME
    If RegOpenKeyEx(HKEY_LOCAL_MACHINE, DRIVERS & drvKey, 0, KEY_READ, hKey) = 0 Then
       With instance
           .DriverDescription = GetValueAsString(hKey, "DriverDesc")
           .DriverVersion = GetValueAsString(hKey, "DriverVersion")
       End With
       RegCloseKey hKey
    End If
    Dim s As String
    If RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SYSTEM\CurrentControlSet\Services\" & instance.ServiceName, 0, KEY_READ, hKey) = 0 Then
       With instance
           .DriverFileName = GetValueAsString(hKey, "ImagePath")
           s = GetValueAsString(hKey, "DisplayName")
           If s <> "" Then .DriverDescription = s
       End With
       RegCloseKey hKey
    End If
End Sub

Private Function SubKeyExists(ByVal hKey As Long, ByVal SubKeyName As String) As Boolean
   Dim hNewkey As Long, ret As Long
   ret = RegOpenKeyEx(hKey, SubKeyName, ByVal 0, KEY_QUERY_VALUE, hNewkey)
   If ret = 0 Then
      RegCloseKey hNewkey
      SubKeyExists = True
   End If
End Function

Private Function GetValueAsString(ByVal hKey As Long, ByVal ValueName As String) As String
   Dim cbSize As Long, lType As Long
   Dim abData() As Byte
   cbSize = MAX_VALUE_SIZE
   ReDim abData(cbSize - 1)
   If RegQueryValueEx(hKey, ValueName, 0&, lType, abData(0), cbSize) = 0 Then
      If cbSize = 0 Then Exit Function
      ReDim Preserve abData(cbSize - 1)
      GetValueAsString = GetRegData(lType, abData)
   End If
End Function

Private Function GetValueAsUnicodeString(ByVal hKey As Long, ByVal ValueName As String) As String
   Dim cbSize As Long, lType As Long
   Dim abData() As Byte
   cbSize = MAX_VALUE_SIZE
   ReDim abData(cbSize - 1)
   If RegQueryValueEx(hKey, ValueName, 0&, lType, abData(0), cbSize) = 0 Then
      If cbSize = 0 Then Exit Function
      ReDim Preserve abData(cbSize - 1)
      GetValueAsUnicodeString = abData
   End If
End Function
